$regfile = "m48def.dat"                                     'file necessary for compilation for AtMega48
$crystal = 22118400                                         'frequency of X-tal 22.1184MHz

Rem Configuration of LCD display
Config Lcd = 20 * 2                                         '2 rows x 20 chars
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portd.7 , Db6 = Portd.6 , Db7 = Portd.5 , Rs = Portb.2 , E = Portb.1
Cursor Off
Cls

Rem Configuration of ADC
Config Adc = Single , Prescaler = Auto

Rem Declarations of variables
Dim Uref As Word
Dim Uf As Long
Dim Ur As Long
Dim Adjust As Word
Dim Swr1 As Long
Dim Swr2 As Long
Dim Swr As Single
Dim Swr$ As String * 3
Dim X As Single
Dim Pwr As Single
Dim Pwr$ As String * 3
Dim Scale(3) As Byte
Dim X_scale As Byte
Dim Scale_$(3) As String * 4
Dim E_scale As Eram Byte
Dim Multiply As Byte

Const Row = "                    "

Rem Config and setting ports
Config Pinc.6 = Input
Config Pinc.5 = Input
Config Pind.0 = Output
Config Pinc.0 = Input
Config Pinc.1 = Input
Config Pinc.2 = Input
Config Pinc.3 = Input

Set Portc.6
Set Portc.5
Set Portc.4
Set Portd.0

Rem show scale
X_scale = E_scale
Gosub Show_scale

Rem MAIN LOOP

Do
Gosub Read_adc
Gosub Calculate_pwr
Gosub Show_pwr
Gosub Calculate_swr
Gosub Show_swr
Waitms 100
Debounce Pinc.5 , 0 , Scale_sub , Sub
Loop


Rem ===============================
Rem ====   SUBS   =================
Rem ===============================

Rem Read ADCs

Read_adc:

Start Adc
Uref = Getadc(1)
Uf = Getadc(0)
Ur = Getadc(2)
Adjust = Getadc(3)                                          'Calculate variable "Adjust"
Adjust = Adjust * 10
Adjust = Adjust + 24000
Stop Adc
Return

Rem ===Calculate SWR====

Calculate_swr:

Swr1 = Uf + Ur
Swr2 = Uf - Ur
Swr = Swr1 / Swr2
Swr$ = Str(swr)
Swr$ = Left(swr$ , 3)

Swr = Log10(swr)                                            'calculate SWR bargraph
Swr = 20 * Swr
Swr = Round(swr)
If Swr > 15 Then
Swr = 15
Swr$ = ">" + Swr$
End If
If Swr < 1 Then
Swr$ = "1.0"
End If
If Swr2 < 0 Then
Swr$ = ">99"
Swr = 15
End If
Return

Rem ===Show SWR=========

Show_swr:

Locate 2 , 1
Lcd Row
Locate 2 , 1

For X = 1 To Swr                                            'show SWR bargraph
Lcd "="
Next
Lcd ">" ; Swr$
Return

Rem ===Calculate PWR===============

Calculate_pwr:

Uf = Uf - Uref
Ur = Ur - Uref
Pwr = Uf ^ 2
Pwr = Pwr / Adjust
If Pwr < 0.05 Then
Pwr = 0.000
End If
Pwr$ = Str(pwr)
Pwr$ = Left(pwr$ , 3)

Pwr = Multiply * Pwr                                        'calculate PWR bargraph
Pwr = Round(pwr)
Return


Rem ===Show PWR============

Show_pwr:

Locate 1 , 1
Lcd Row
Locate 1 , 1

If Pwr > 20 Then
Pwr = 20
End If

For X = 1 To Pwr                                            'show PWR bargraph
Lcd "="
Next
Lcd ">"
                                                             'if bargraph too long, place number in the middle.
If Pwr > 16 Then
Locate 1 , 9
End If

Lcd Pwr$
Return

Rem ===Switch scale of PWR bargraph ========

Scale_sub:
X_scale = E_scale

Incr X_scale
  If X_scale > 3 Then
  X_scale = 1
  End If

Gosub Show_scale

Return

Rem ===Show PWR bargraph scale ============

Show_scale:

Scale_$(1) = "20 W"
Scale_$(2) = "5 W"
Scale_$(3) = "2 W"
Scale(1) = 1
Scale(2) = 4
Scale(3) = 10
Multiply = Scale(x_scale)
E_scale = X_scale                                           'save PWR bargraph scale into eeprom
Cls
Locate 1 , 4
Lcd "ROZSAH: " ; Scale_$(x_scale)                           'range of bargraf
Wait 3
Return


End                                                         'end program